=== debian/changelog ===
ignition-msgs (0.5.0-1) unstable; urgency=medium

  * Imported Upstream version 0.5.0

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 12 Sep 2016 17:01:28 +0000

ignition-msgs (0.4.0-3) unstable; urgency=medium

  * Fix typo in VSC browser
  * Fix pkgconfig file name

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 11 Sep 2016 19:45:38 +0000

ignition-msgs (0.4.0-2) unstable; urgency=medium

  * Added patch to respect CFLAGS
  * Added patch to fix pkgconfig file

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 06 Sep 2016 21:19:33 +0000

ignition-msgs (0.4.0-1) unstable; urgency=medium

  * Imported Upstream version 0.4.0 (Closes: #832042)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 27 Jul 2016 22:29:45 +0000
