## ignition-msgs 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 string (SUBSTRING ${PROJECT_NAME} 9 4 IGN_PROJECT_NAME)
 
 string (SUBSTRING ${PROJECT_NAME} 13 -1 PROJECT_MAJOR_VERSION)
-set (PROJECT_MINOR_VERSION 5)
-set (PROJECT_PATCH_VERSION 0)
+set (PROJECT_MINOR_VERSION 6)
+set (PROJECT_PATCH_VERSION 1)
 
 set(PROJECT_NAME_NO_VERSION "ignition-${IGN_PROJECT_NAME}")
 string (TOLOWER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_LOWER)
