=== debian/changelog ===
ignition-msgs (0.6.1-1) unstable; urgency=medium

  * Imported Upstream version 0.6.1

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 17 Jan 2017 00:03:26 +0000
