=== debian/control ===
Source: ignition-msgs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Testsuite: autopkgtest
Priority: extra
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9.20151004),
               libgtest-dev,
               libprotoc-dev,
               libprotobuf-dev (>= 2.3.0),
               libignition-math2-dev,
               protobuf-compiler,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ignition-msgs.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ignition-msgs.git
Homepage: http://ignitionrobotics.org/libraries/msgs

Package: libignition-msgs0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Shared library
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the main message library.

Package: libignition-msgs-dev
Architecture: any
Section: libdevel
Depends: libprotobuf-dev (>= 2.3.0),
         libignition-math2-dev,
         libignition-msgs0 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Dev files
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the headers and other tools for development.
