## ignition-msgs 1.0.0%2Bdfsg1

=== debian/changelog ===
ignition-msgs (1.0.0+dfsg1-5) unstable; urgency=medium

  * Include the missing the yaml file to fix current broken ign-tools support

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 Mar 2018 17:26:43 +0000

ignition-msgs (1.0.0+dfsg1-4) unstable; urgency=medium

  * Include ruby ignition-tools file in the -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 Mar 2018 12:21:04 +0000

ignition-msgs (1.0.0+dfsg1-3) unstable; urgency=medium

  * Missing protobuf dependencies in -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 05 Feb 2018 17:03:38 +0000

ignition-msgs (1.0.0+dfsg1-2) unstable; urgency=medium

  * Use ign-math4 instead of ign-math2 and remove deprecated patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 22 Jan 2018 16:35:03 +0100

ignition-msgs (1.0.0+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 1.0.0
  * Migrate metadata to 1.x series

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 05 Jan 2018 20:29:04 +0000

ignition-msgs (0.7.0-1) unstable; urgency=medium

  * Remove merged pkgconfig patch
  * Imported Upstream version 0.7.0

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 05 Sep 2017 22:17:05 +0000
