=== debian/control ===
--- 
+++ 
@@ -2,22 +2,22 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science
-Testsuite: autopkgtest
-Priority: extra
+Priority: optional
 Build-Depends: cmake,
                pkg-config,
-               debhelper (>= 9.20151004),
+               debhelper (>= 11),
                libgtest-dev,
                libprotoc-dev,
                libprotobuf-dev (>= 2.3.0),
-               libignition-math2-dev,
+               libignition-math4-dev,
+               libignition-cmake-dev,
                protobuf-compiler,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ignition-msgs.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ignition-msgs.git
 Homepage: http://ignitionrobotics.org/libraries/msgs
 
-Package: libignition-msgs0
+Package: libignition-msgs
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -33,8 +33,11 @@
 Architecture: any
 Section: libdevel
 Depends: libprotobuf-dev (>= 2.3.0),
-         libignition-math2-dev,
-         libignition-msgs0 (= ${binary:Version}),
+         libprotoc-dev,
+         protobuf-compiler,
+         libignition-math4-dev,
+         libignition-cmake-dev,
+         libignition-msgs (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: same
 Description: Set of message definitions used by robotics apps - Dev files
