=== debian/tests/control ===
Tests: build
Depends: libignition-msgs-dev, pkg-config, build-essential
